package jp.gr.java_conf.coskx.teststrageapi30commomareaapi33;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.os.Bundle;
import android.provider.DocumentsContract;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.activity.result.ActivityResultLauncher;
import androidx.activity.result.contract.ActivityResultContracts;
import androidx.appcompat.app.AppCompatActivity;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.util.Locale;

public class MainActivity extends AppCompatActivity implements View.OnClickListener {
    private final static String TAG = "MainActivity";

    private TextView uriDisplay;
    private TextView loadedTextDisplay;
    private Button save1;
    private Button load1;
    private Button save2;
    private Button load2;
    private Button delete;
    private ImageView imageview1;
    private ImageView imageview2;
    private String textToBeSaved; //ファイルに書き込む内容　インスタンス変数でなければならない
    private Bitmap bitmapToBeSaved; //ファイルに書き込む内容　インスタンス変数でなければならない

    //API33からの新しい
    private Intent intent_createTextfile;
    private ActivityResultLauncher<Intent> launcher_createTextfile;
    private Intent intent_loadTextfile;
    private ActivityResultLauncher<Intent> launcher_loadTextfile;
    private Intent intent_createImagefile;
    private ActivityResultLauncher<Intent> launcher_createImagefile;
    private Intent intent_loadImagefile;
    private ActivityResultLauncher<Intent> launcher_loadImagefile;
    private Intent intent_DeleteFile;
    private ActivityResultLauncher<Intent> launcher_DeleteFile;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        uriDisplay = findViewById(R.id.uritextview);
        loadedTextDisplay = findViewById(R.id.result1);
        save1 = findViewById(R.id.save1);
        save1.setOnClickListener(this);
        load1 = findViewById(R.id.load1);
        load1.setOnClickListener(this);
        save2 = findViewById(R.id.save2);
        save2.setOnClickListener(this);
        load2 = findViewById(R.id.load2);
        load2.setOnClickListener(this);
        delete = findViewById(R.id.delete);
        delete.setOnClickListener(this);
        delete.setEnabled(false); //なんでも消せます。危ないので無効化しておく　有効にしてテストしてください

        imageview1 = findViewById(R.id.imageview1);
        imageview2 = findViewById(R.id.imageview2); //読み込んだimageを表示

        bitmapToBeSaved = BitmapFactory.decodeResource(getResources(), R.drawable.sample_image);
        imageview1.setImageBitmap(bitmapToBeSaved); //書込テスト用imageを表示
        Bitmap bitmapEmpty = BitmapFactory.decodeResource(getResources(), R.drawable.jpg);
        imageview2.setImageBitmap(bitmapEmpty); //ダミーimageを表示

        setIntentCreateTextfile();
        setIntentLoadTextfile();
        setIntentCreateImagefile();
        setIntentLoadImagefile();
        setIntentDeleteFile();
    }

    private void setIntentCreateTextfile() {
        intent_createTextfile = new Intent(Intent.ACTION_CREATE_DOCUMENT);
        intent_createTextfile.addCategory(Intent.CATEGORY_OPENABLE);
        intent_createTextfile.setType("text/plain");
        launcher_createTextfile = registerForActivityResult(
            new ActivityResultContracts.StartActivityForResult(),
            result -> {
                if (result.getResultCode() == Activity.RESULT_OK && null != result.getData()) {
                    Uri uri = result.getData().getData();
                    // Uriを表示
                    String uritext = String.format(Locale.US, "Uri:　%s",uri.getPath());
                    uriDisplay.setText(uritext);
                    Log.i(TAG,"launcher_createTextfile > " + uritext);
                    // launcher_createTextfile > Uri:　/document/primary:test0/SampleText.txt

                    //android5(24)  ピッカーはデフォルト保存先は見せないが，本体STrage,SDcardとgoogledriveも選択OK
                    //android8(27)  ピッカーはデフォルトでDownloadを保存先として見せるが，SDcardとgoogledriveも選択OK
                    //android9(28)  ピッカーはデフォルトでDownloadを保存先として見せるが，本体STrage,SDcardとgoogledriveも選択OK
                    //android10(29)  ピッカーはデフォルトでDownloadを保存先として見せるが，本体STrage,SDcardとgoogledriveも選択OK
                    //android11(30)  ピッカーはデフォルトでDownloadを保存先として見せるが，本体STrage,SDcardとgoogledriveも選択OK
                    //既存ファイルと同じファイル名で上書きしようとしてもできない
                    //SampleText.txt，SampleText (1).txt，SampleText (2).txt，SampleText (3).txt，...が出来てしまう。

                    try(OutputStream outputStream = getContentResolver().openOutputStream(uri)) {
                        if(outputStream != null){
                            outputStream.write(textToBeSaved.getBytes());
                        }

                    } catch(Exception e){
                        e.printStackTrace();
                    }
                }
            }
        );
    }

    private void setIntentLoadTextfile() {
        intent_loadTextfile = new Intent(Intent.ACTION_OPEN_DOCUMENT);
        intent_loadTextfile.addCategory(Intent.CATEGORY_OPENABLE);
        intent_loadTextfile.setType("text/plain");
        launcher_loadTextfile = registerForActivityResult(
            new ActivityResultContracts.StartActivityForResult(),
            result -> {
                if (result.getResultCode() == Activity.RESULT_OK && null != result.getData()) {
                    Uri uri = result.getData().getData();
                    // Uriを表示
                    String uritext = String.format(Locale.US, "Uri:　%s", uri.getPath());
                    uriDisplay.setText(uritext);
                    Log.i(TAG, "launcher_loadTextfile > " + uritext);
                    // launcher_loadTextfile > Uri:　/document/primary:test0/SampleText.txt

                    StringBuilder text = new StringBuilder();
                    try(InputStream inputStream = getContentResolver().openInputStream(uri);
                        InputStreamReader inputStreamReader = new InputStreamReader(inputStream);
                        BufferedReader reader = new BufferedReader(inputStreamReader)) {
                        String lineBuffer;
                        lineBuffer = reader.readLine();
                        while (lineBuffer != null) {
                            text.append(lineBuffer).append("\n");
                            lineBuffer = reader.readLine();
                        }
                        Log.i(TAG, "text read = [" + text + "]");
                        loadedTextDisplay.setText(text.toString());
                    } catch(Exception e) {
                        e.printStackTrace();
                    }
                }
            }
        );
    }

    private void setIntentCreateImagefile() {
        intent_createImagefile = new Intent(Intent.ACTION_CREATE_DOCUMENT);
        intent_createImagefile.addCategory(Intent.CATEGORY_OPENABLE);
        //intent_createImagefile.setType("image/jpeg");
        intent_createImagefile.setType("*/*"); //フィルタリングだけのようだからこれでも構わない
        launcher_createImagefile = registerForActivityResult(
            new ActivityResultContracts.StartActivityForResult(),
            result -> {
                if (result.getResultCode() == Activity.RESULT_OK && null != result.getData()) {
                    Uri uri = result.getData().getData();
                    // Uriを表示
                    String uritext = String.format(Locale.US, "Uri:　%s", uri.getPath());
                    uriDisplay.setText(uritext);
                    Log.i(TAG, "launcher_createImagefile > " + uritext);
                    // launcher_createImagefile > Uri:　/document/primary:test0/SampleImage.jpg

                    try(OutputStream outputStream = getContentResolver().openOutputStream(uri)) {
                        if(outputStream != null){
                            bitmapToBeSaved.compress(Bitmap.CompressFormat.JPEG, 100, outputStream);
                        }
                    } catch(Exception e){
                        e.printStackTrace();
                    }
                }
            }
        );
    }

    private void setIntentLoadImagefile() {
        intent_loadImagefile = new Intent(Intent.ACTION_OPEN_DOCUMENT);
        intent_loadImagefile.addCategory(Intent.CATEGORY_OPENABLE);
        //intent_loadImagefile.setType("image/jpeg");
        intent_loadImagefile.setType("*/*"); //フィルタリングだけのようだからこれでも構わない
        launcher_loadImagefile = registerForActivityResult(
            new ActivityResultContracts.StartActivityForResult(),
            result -> {
                if (result.getResultCode() == Activity.RESULT_OK && null != result.getData()) {
                    Uri uri = result.getData().getData();
                    // Uriを表示
                    String uritext = String.format(Locale.US, "Uri:　%s", uri.getPath());
                    uriDisplay.setText(uritext);
                    Log.i(TAG, "launcher_loadImagefile > " + uritext);
                    // launcher_loadImagefile > Uri:　/document/primary:test0/SampleImage.jpg

                    try(InputStream inputStream = getContentResolver().openInputStream(uri);
                        BufferedInputStream bufferedInputStream = new BufferedInputStream(inputStream)) {
                        Bitmap bitmap = BitmapFactory.decodeStream(bufferedInputStream);
                        imageview2.setImageBitmap(bitmap);
                    } catch(Exception e){
                        e.printStackTrace();
                    }
                }
            }
        );
    }

    private void setIntentDeleteFile() {
        intent_DeleteFile = new Intent(Intent.ACTION_OPEN_DOCUMENT);
        intent_DeleteFile.addCategory(Intent.CATEGORY_OPENABLE);
        intent_DeleteFile.setType("*/*"); //フィルタリングだけのようだからこれでも構わない
        launcher_DeleteFile = registerForActivityResult(
                new ActivityResultContracts.StartActivityForResult(),
                result -> {
                    if (result.getResultCode() == Activity.RESULT_OK && null != result.getData()) {
                        Uri uri = result.getData().getData();
                        // Uriを表示
                        String uritext = String.format(Locale.US, "Uri:　%s", uri.getPath());
                        uriDisplay.setText(uritext);
                        Log.i(TAG, "launcher_DeleteFile > " + uritext);
                        // launcher_DeleteFile > Uri:　/document/primary:test0/SampleImage.jpg
                        try {
                            DocumentsContract.deleteDocument(this.getContentResolver(), uri);
                        } catch (FileNotFoundException e) {
                            e.printStackTrace();
                        }
                    }
                }
        );
    }

    public void onClick(View view) {
        if (view == save1) {  //共通領域にテキストファイルを書き込む。 書き込む先は実行時にユーザが決める
            //書込用textはインスタンス変数で無ければならないが，書込Intent呼び出しまでに確定されていればよい
            textToBeSaved = "Hello,\nThis is a sample text to share.\nIt's working.\n";
            //書込用ファイル名（候補）は保存Intent呼び出しまでに確定されていればよい
            String textfname = "SampleText.txt";
            intent_createTextfile.putExtra(Intent.EXTRA_TITLE, textfname);
            //書込Intentの呼び出し
            launcher_createTextfile.launch(intent_createTextfile);
        } else if (view == load1) {  //共通領域からテキストファイルを読み込む。読み取り対象は実行時にユーザが決める
            launcher_loadTextfile.launch(intent_loadTextfile);
        } else if (view == save2) {  //共通領域に画像ファイルを書き込む。 書き込む先は実行時にユーザが決める
            //書込用ファイル名（候補）は書込Intent呼び出しまでに確定されていればよい
            String imagefname = "SampleImage.jpg";
            intent_createImagefile.putExtra(Intent.EXTRA_TITLE, imagefname);
            //書込Intentの呼び出し
            launcher_createImagefile.launch(intent_createImagefile);
        } else if (view == load2) {  //共通領域から画像ファイルを読み込む。読み取り対象は実行時にユーザが決める
            launcher_loadImagefile.launch(intent_loadImagefile);
        } else if (view == delete) {  //共通領域からファイルを削除する。対象は実行時にユーザが決める
            launcher_DeleteFile.launch(intent_DeleteFile);
        }
    }
}